import type { PeerStore } from '@libp2p/interface-peer-store';
import type { ConnectionManager } from '@libp2p/interface-connection-manager';
import type { Startable } from '@libp2p/interfaces/startable';
interface AutoDialInit {
    minConnections?: number;
    autoDialConcurrency?: number;
    autoDialPriority?: number;
    autoDialInterval?: number;
}
interface AutoDialComponents {
    connectionManager: ConnectionManager;
    peerStore: PeerStore;
}
export declare class AutoDial implements Startable {
    private readonly connectionManager;
    private readonly peerStore;
    private readonly queue;
    private readonly minConnections;
    private readonly autoDialPriority;
    private readonly autoDialIntervalMs;
    private autoDialInterval?;
    private started;
    /**
     * Proactively tries to connect to known peers stored in the PeerStore.
     * It will keep the number of connections below the upper limit and sort
     * the peers to connect based on whether we know their keys and protocols.
     */
    constructor(components: AutoDialComponents, init: AutoDialInit);
    isStarted(): boolean;
    start(): void;
    afterStart(): void;
    stop(): void;
    autoDial(): Promise<void>;
}
export {};
//# sourceMappingURL=auto-dial.d.ts.map